﻿Class MainWindow

    Private Sub BinButton_Click(sender As Object, e As RoutedEventArgs) Handles BinButton.Click
        NumberProcess(2)
    End Sub

    Private Sub QuadButton_Click(sender As Object, e As RoutedEventArgs) Handles QuadButton.Click
        NumberProcess(4)
    End Sub

    Private Sub OctButton_Click(sender As Object, e As RoutedEventArgs) Handles OctButton.Click
        NumberProcess(8)
    End Sub

    Sub NumberProcess(Base As Integer)

        Dim Number As Integer
        If Integer.TryParse(NumberTextBox.Text, Number) Then
            MessageLabel.Content = BaseNumber(Number, Base)
        Else
            MessageLabel.Content = "整数を入力してください"
        End If

    End Sub

    Function BaseNumber(n As Integer, Base As Integer) As String

        Dim ValueStr As String = ""
        Dim Num As Integer = Math.Abs(n)
        Dim Digit As Integer

        If Base >= 2 And Base <= 10 Then
            Do
                Digit = Num Mod Base
                Num \= Base
                ValueStr = Digit & ValueStr
            Loop Until Num < 1
            If n < 0 Then
                ValueStr = "-" & ValueStr
            End If
        End If

        Return ValueStr

    End Function
End Class
