﻿Class MainWindow 

    Private Sub GoButton_Click(sender As Object, e As RoutedEventArgs) Handles GoButton.Click

        Dim NowDate As Date = Date.Today
        Dim ThisMonthPayDate As Date = PayDate(NowDate)

        If NowDate = ThisMonthPayDate Then
            MessageLabel.Content = "本日は給料日です"
        ElseIf NowDate < ThisMonthPayDate Then
            MessageLabel.Content = String.Format(
                "次の給料日は{0:yyyy年M月d日です}", ThisMonthPayDate)
        Else
            Dim NextPayDate As Date = PayDate(NowDate.AddMonths(1))
            MessageLabel.Content = String.Format(
                "次の給料日は{0:yyyy年M月d日です}", NextPayDate)
        End If

    End Sub

    Function PayDate(d As Date) As Date

        Dim IsBusinessDate = Function(dt As Date) dt.DayOfWeek <>
                                 DayOfWeek.Saturday And dt.DayOfWeek <> DayOfWeek.Sunday
        Dim CurrentDate As Date = New Date(d.Year, d.Month, 25)
        Do Until IsBusinessDate(CurrentDate)
            CurrentDate = CurrentDate.AddDays(-1)
        Loop
        Return CurrentDate

    End Function
End Class
