﻿Imports System.IO
Imports System.Text
Imports System.Windows.Resources
Class MainWindow

    Dim YubinList As List(Of String)

    Private Sub GoButton_Click(sender As Object, e As RoutedEventArgs) Handles GoButton.Click

        If YubinList Is Nothing Then
            ReadFile()
        End If
        Dim SearchNum As String = ZipTextBox.Text
        SearchNum = SearchNum.Replace("-", "")

        ZipListBox.Items.Clear()

        Dim HyphenString =
            Function(x As String) IIf(x.Length > 6,
                                      x.Substring(0, 3) & "-" & x.Substring(3), x)

        For i As Integer = 0 To YubinList.Count - 1
            If SearchNum = YubinList(i).Substring(0, Math.Min(
                                                  SearchNum.Length, YubinList(i).Length)) Then
                Dim ZipItem As ListBoxItem =
                    New ListBoxItem()
                ZipItem.Content = HyphenString(YubinList(i))
                ZipListBox.Items.Add(ZipItem)
            End If
        Next

    End Sub

    Sub ReadFile()

        YubinList = New List(Of String)()

        Dim YubinInfo As StreamResourceInfo =
            Application.GetContentStream(New Uri("/Yubin.txt",
                                                 UriKind.Relative))
        Dim sr As StreamReader = New StreamReader(YubinInfo.Stream,
                                                  Encoding.GetEncoding("shift_jis"))
        Dim Buffer As String

        Buffer = sr.ReadLine()
        Do Until Buffer Is Nothing
            YubinList.Add(Buffer)
            Buffer = sr.ReadLine()
        Loop
        sr.Close()

    End Sub
End Class
