﻿Imports System.IO
Imports System.Text
Class MainWindow

    Private Sub GoButton_Click(sender As Object, e As RoutedEventArgs) Handles GoButton.Click

        Dim ReadFileName = MyPath("Data.txt")
        Dim WriteFileName = MyPath("Linenum.txt")

        Dim fs1, fs2 As FileStream
        Dim sr As StreamReader
        Dim sw As StreamWriter
        Dim Buffer As String
        Dim LineNum As Integer = 1

        Try
            fs1 = New FileStream(ReadFileName, FileMode.Open)
            fs2 = New FileStream(WriteFileName, FileMode.Create)
            sr = New StreamReader(fs1,
                                  Encoding.GetEncoding("shift_jis"))
            sw = New StreamWriter(fs2,
                                  Encoding.GetEncoding("shift_jis"))
            Buffer = sr.ReadLine()
            Do Until Buffer Is Nothing
                sw.WriteLine("{0:0000}:{1}", LineNum, Buffer)
                LineNum += 1
                Buffer = sr.ReadLine()
            Loop
            MessageLabel.Content = "処理が終わりました"
        Catch ex As FileNotFoundException
            MessageLabel.Content = "ファイルがみつかりません"
        Catch ex As UnauthorizedAccessException
            MessageLabel.Content = "アクセス権がありません"
        Catch ex As IOException
            MessageLabel.Content = ex.Message
        Finally
            If sr IsNot Nothing Then
                sr.Close()
            End If
            If sw IsNot Nothing Then
                sw.Close()
            End If
        End Try

    End Sub

    Function MyPath(Filename As String)
        Return Path.Combine(Path.GetDirectoryName(
                            Application.ResourceAssembly.Location), Filename)
    End Function
End Class
