﻿Imports System.Windows.Threading
Class MainWindow

    Const CountSeconds As Integer = 10
    Dim MyTimer As DispatcherTimer
    Dim BaseDateTime As Date

    Private Sub GoButton_Click(sender As Object, e As RoutedEventArgs) Handles GoButton.Click

        If MyTimer.IsEnabled Then
            MyTimer.Stop()
            GoButton.Content = "開始"
            MessageLabel.Content = "カウントを中止しました"
        Else
            GoButton.Content = "中止"
            BaseDateTime = Date.Now
            MyTimer.Start()
        End If

    End Sub

    Private Sub Timer_Tick(sender As Object, e As EventArgs)

        Dim Lapse As TimeSpan = Date.Now - BaseDateTime
        MessageLabel.Content =
            CountSeconds - Math.Floor(Lapse.TotalSeconds)
        If Lapse.TotalSeconds > CountSeconds Then
            MyTimer.Stop()
            GoButton.Content = "開始"
            MessageBox.Show("タイムアウトになりました", "カウントダウン",
                            MessageBoxButton.OK, MessageBoxImage.Information)
        End If

    End Sub

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded

        MyTimer = New DispatcherTimer()
        MyTimer.Interval = New TimeSpan(0, 0, 0, 0, 50)
        AddHandler MyTimer.Tick, AddressOf Timer_Tick

    End Sub
End Class
