﻿Class MainWindow 

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded

        For Each Family As FontFamily In Fonts.SystemFontFamilies
            Dim MyItem As ListBoxItem = New ListBoxItem()
            MyItem.Content = Family.Source
            MyItem.Tag = Family
            FontListBox.Items.Add(MyItem)
        Next

    End Sub

    Private Sub FontListBox_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles FontListBox.SelectionChanged

        MessageLabel.FontFamily =
            CType(FontListBox.SelectedItem, ListBoxItem).Tag

    End Sub

    Private Sub BoldCheckBox_Checked(sender As Object, e As RoutedEventArgs) Handles BoldCheckBox.Checked
        MessageLabel.FontWeight = FontWeights.Bold
    End Sub

    Private Sub BoldCheckBox_Unchecked(sender As Object, e As RoutedEventArgs) Handles BoldCheckBox.Unchecked
        MessageLabel.FontWeight = FontWeights.Normal
    End Sub

    Private Sub ItalicCheckBox_Checked(sender As Object, e As RoutedEventArgs) Handles ItalicCheckBox.Checked
        MessageLabel.FontStyle = FontStyles.Italic
    End Sub

    Private Sub ItalicCheckBox_Unchecked(sender As Object, e As RoutedEventArgs) Handles ItalicCheckBox.Unchecked
        MessageLabel.FontStyle = FontStyles.Normal
    End Sub
End Class
