﻿Class MainWindow

    Private Sub DisplayCheckBox_Checked(sender As Object, e As RoutedEventArgs) Handles DisplayCheckBox.Checked

        AddHandler MainTextBox.TextChanged,
            AddressOf MainTextBox_TextChanged
        DisplayLength()

    End Sub

    Private Sub DisplayCheckBox_Unchecked(sender As Object, e As RoutedEventArgs) Handles DisplayCheckBox.Unchecked

        RemoveHandler MainTextBox.TextChanged,
            AddressOf MainTextBox_TextChanged
        MessageLabel.Content = ""

    End Sub

    Sub DisplayLength()
        MessageLabel.Content =
            "文字数は" & MainTextBox.Text.Length & "文字です"
    End Sub

    Private Sub MainTextBox_TextChanged(sender As Object,
                                        e As TextChangedEventArgs)
        DisplayLength()
    End Sub
End Class
