﻿Class MainWindow 

    Private Sub GoButton_Click(sender As Object, e As RoutedEventArgs) Handles GoButton.Click

        Dim InputDate, CountDate As Date
        Dim BusinessDay As Integer = 0

        Dim IsBusinessDate = Function(d As Date) d.DayOfWeek <>
                                 DayOfWeek.Saturday And d.DayOfWeek <> DayOfWeek.Sunday

        If Date.TryParse(DateTextBox.Text, InputDate) Then

            CountDate = New Date(InputDate.Year, InputDate.Month, 1)
            If IsBusinessDate(InputDate) Then
                Do
                    BusinessDay += IIf(IsBusinessDate(CountDate), 1, 0)
                    CountDate = CountDate.AddDays(1)
                Loop Until CountDate > InputDate
                MessageLabel.Content = "月の第" & BusinessDay & "営業日です"
            Else
                MessageLabel.Content = "営業日ではありません"
            End If
        Else
            MessageLabel.Content = "日付を入力してください"
        End If

    End Sub
End Class
