﻿Imports System.IO
Imports System.ComponentModel
Class MainWindow

    Dim MyBackgroundWorker As BackgroundWorker

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded

        MyBackgroundWorker = New BackgroundWorker()
        AddHandler MyBackgroundWorker.DoWork,
            AddressOf BackgroundWorker_DoWork
        AddHandler MyBackgroundWorker.RunWorkerCompleted,
            AddressOf BackgroundWorker_RunWorkerCompleted

    End Sub

    Private Sub BackgroundWorker_DoWork(sender As Object, e As DoWorkEventArgs)

        For i As Integer = 1 To 5
            WriteFile(Path.Combine(Path.GetDirectoryName(
                Application.ResourceAssembly.Location), "Alphabet" & i))
        Next

    End Sub

    Private Sub BackgroundWorker_RunWorkerCompleted(sender As Object, e As RunWorkerCompletedEventArgs)

        If e.Error Is Nothing Then
            MessageLabel.Content = "処理が終わりました"
        Else
            MessageBox.Show(e.Error.Message, Me.Title,
                MessageBoxButton.OK, MessageBoxImage.Error)
        End If
        GoButton.IsEnabled = True

    End Sub

    Sub WriteFile(fn As String)

        Dim r As Random = New Random()
        Dim sw As StreamWriter = New StreamWriter(fn)
        Dim s As String =
            "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
        For i As Integer = 1 To 104857600
            sw.Write(s.Chars(r.Next(s.Length)))
        Next
        sw.Close()

    End Sub

    Private Sub GoButton_Click(sender As Object, e As RoutedEventArgs) Handles GoButton.Click

        GoButton.IsEnabled = False
        MyBackgroundWorker.RunWorkerAsync()

    End Sub
End Class
